;    14-12-05
;  2*16

;	   2 , 
;	   -   ( )
; 	  -     <texts.h> 
;
;   = 4 
;    WH1602C

;    /// oleg.omsk@usa.net

		LIST		p=16f628a

;   <my_mac.inc>    ,  
;   
	include <my_mac.inc>
	include <p16f628A.inc>


		__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON &_HS_OSC & _MCLRE_ON & _LVP_OFF

place equ	.1 ; (1...23)      
 
#define _int	flag,0	;  'pp p'
#define _bank	flag,1	;  '  '
#define _zw	PORTA,2 ;   


LCD_DATA         	EQU     PORTB
LCD_DATA_TRIS    EQU     TRISB-0x80
;
LCD_CNTL         	EQU     PORTB
LCD_CNTL_TRIS    	EQU     TRISB-0x80
;
; LCD Display Commands and Control Signal names.
;
E       	EQU     1       ; LCD Enable control line
R_W     	EQU     2       ; LCD Read/Write control line
RS      	EQU     3       ; LCD Register Select control line

; ++++++++++++++++++++++++++++    +++++++++++++++++
; 4...7 	- 
; 1		- 
; 2		- R/W
; 3		- RS

zw1ton  	equ	d'160'
zw2ton	equ	d'180'
zw3ton  	equ	d'220'
zw4ton  	equ 	d'255'

	CBLOCK H'20'

rab1	; bcd
rab2	; bcd, delay20, delay5
rab3	; bcd, delay1 
rab4	; 
rab5	;     LCD
Temp	; (LCD)- busy    DDRAM
Char	; (LCD)-c     
t50ms 	;  p   
t1sec
t1min	
t1hour

push_W	;     W  STATUS p INT...
push_S	
flag
	ENDC

 org     0x00
		goto    START
 org     0x04
		goto	interrupt

Table:
	addwf   PCL,f           ; Jump to character
	include "texts.h"
START 	
	call init_reg
	call    LCD_Init        ; Set up the LCD Module
	movlw   CLR_DISP	; ...
	call    Send_Cmd
	movlw   b'00001111'	; Display on, cursor on, blink on
	call    Send_Cmd
	movlw   b'00000110'	; Increment cursor (Entry_Set)
	call    Send_Cmd
	movlw	LINE2+.15    	;   
	call 	Send_Cmd

;        goto $
;
long
	movlw   0               ; Table address (start of message)
	call string
        nop
	goto long

; ********************************************************
;       Table (  W)
; ********************************************************

string				
	movwf   rab5       ; rab5 holds start of message address
	call    Table
	andlw   0FFh            
	btfsc   STATUS,Z   ; Check if at end of message (zero returned at end)
	return		   ; goto    out
	call    Send_Char  ; Display character

	call	delay100   ;    -   

;    ,   " "
	movlw b'00011100'  ;    '11000'   
	call scmd
	call	delay10   ;   

;       ,     
;   
	call Wait_Busy		;   
        cmp Temp,0x68	;      1- ?
  	sz
	goto prod
	movlw LINE2	;    2- 
	call scmd
 	call Wait_Busy		;   

prod

;     DDRAM 
;   ,      2  
;        

; 	call str1
	movf    rab5,w     ; Point to next character
	addlw   1
	goto    string

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;                   
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
str1
	call Wait_Busy	   ;      2- 
	movff Temp,rab4	   ;   

	cmp Temp,0x40+.15    	; - to right
	sc		
	goto mgr	   ; Temp < 
; Temp > 
	movlw 0x40+.16-place	 ;       
	subwf Temp,w	  	 ;    
	goto combm
mgr
	movlw 0x40	   ;   ""  40-16=24
	subwf Temp,w	   ;    
	addlw .24+place	   ; 
	goto combm
combm
	iorlw b'10000000'  ; for DD RAM Adress Set
	call	Send_Cmd
;     1- 
;	movlw '	'	;     
;	call sch_b
	movlw 'T'
	call sch_b
	movlw 'i'
	call sch_b
	movlw 'm'
	call sch_b
	movlw 'e'
	call sch_b
	movlw ' '
	call sch_b
	movlw 'i'
	call sch_b
	movlw 's'
	call sch_b
	movlw ' '
	call sch_b

	call time			;    LCD
	movf rab4,w		;     2 
	iorlw b'10000000'	; for DD RAM Adress Set
	call	Send_Cmd
	return
;
sch_b			;       2 
	call schar
	call Wait_Busy		;   ?
	cmp Temp,0x40	;      2- ?
	sz	
	return
	movlw LINE1	;    1- 
	call scmd
	return

; ********************************************************************
;                     
; ********************************************************************

time
	movf t1hour,w	;   
	call bcd	;   . 
	movf rab2,w
	addlw 0x30	;  
	call sch_b	; ,  r1...r3

	movf t1hour,w
	call bcd
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movlw '-'
	call sch_b	; use r1...r3

	movf t1min,w
	call bcd
	movf rab2,w
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movf t1min,w
	call bcd
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movlw '-'
	call sch_b	; use r1...r3

	movf t1sec,w
	call bcd
	movf rab2,w
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movf t1sec,w
	call bcd
	addlw 0x30	;  
	call sch_b	; use r1...r3
	return

;
;*******************************************************************
;* The LCD Module Subroutines                                      *
;*******************************************************************
;
;*******************************************************************
;*SendChar - Sends character to LCD                                *
;*This routine splits the character into the upper and lower       * 
;*nibbles and sends them to the LCD, upper nibble first.           *
;*******************************************************************
;
schar
Send_Char
	movwf   Char            ; Character to be sent is in W
	call    Wait_Busy       ; Wait for LCD to be ready
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movf    Char,w          
	andlw   0xF0            ; Get upper nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bcf     LCD_CNTL, R_W   ; Set LCD to write
	bsf     LCD_CNTL, RS    ; Set LCD to data mode
	bsf     LCD_CNTL, E     ; toggle E for LCD
	bcf     LCD_CNTL, E
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	swapf   Char,W
	andlw   0xF0            ; Get lower nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bsf     LCD_CNTL, E     ; toggle E for LCD
	bcf     LCD_CNTL, E
	return

;*******************************************************************
;* Send_Cmd - Sends command to LCD                                 *
;* This routine splits the command into the upper and lower        * 
;* nibbles and sends them to the LCD, upper nibble first.          *
;*******************************************************************
scmd
Send_Cmd
	movwf   Char            ; Character to be sent is in W
	call    Wait_Busy       ; Wait for LCD to be ready
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movf    Char,w          
	andlw   0xF0            ; Get upper nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bcf     LCD_CNTL,R_W    ; Set LCD to write
	bcf     LCD_CNTL,RS     ; Set LCD to command mode
	bsf     LCD_CNTL,E      ; toggle E for LCD
	bcf     LCD_CNTL,E
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	swapf   Char,W
	andlw   0xF0            ; Get lower nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bsf     LCD_CNTL,E      ; toggle E for LCD
	bcf     LCD_CNTL,E
	return
;
;*******************************************************************
;* This routine checks the busy flag, returns when not busy        *
;*  Affects:                                                       *
;*      Temp - Returned with busy/address                          *
;*******************************************************************
;     ! - 
Wait_Busy
	bsf     STATUS, RP0     ; Select Register page 1
	movlw   0xf0            ; Set port to input
	iorwf   LCD_DATA_TRIS,W ; Only set upper half of port
	movwf   LCD_DATA_TRIS
	bcf     STATUS, RP0     ; Select Register page 0
	bcf     LCD_CNTL, RS    ; Set LCD for Command mode
	bsf     LCD_CNTL, R_W   ; Setup to read busy flag

	bsf     LCD_CNTL, E     ; Set E high
	movf    LCD_DATA, W     ; Read upper nibble busy flag, DDRam address
	bcf     LCD_CNTL, E     ; Set E low

	andlw   0xF0            ; Mask out lower nibble
	movwf   Temp

	bsf     LCD_CNTL, E     ; Toggle E to get lower nibble
	swapf   LCD_DATA, w     ; Read lower nibble busy flag, DDRam address
	bcf     LCD_CNTL, E


	andlw   0x0F            ; Mask out upper nibble
	iorwf   Temp,f          ; Combine nibbles, RES in Temp !!!!!!!!!!!!!!!
	btfsc   Temp, 7         ; Check busy flag, high = busy
	goto    Wait_Busy       ; If busy, check again
	bcf     LCD_CNTL, R_W        
	bsf     STATUS, RP0     ; Select Register page 1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS   ; Set Port for output
	bcf     STATUS, RP0     ; Select Register page 0
	return
;
del10mks
	goto $+1
	goto $+1
	goto $+1
	goto $+1
	return
;
; Initilize the LCD Display Module
;
LCD_Init:

	bcf     LCD_CNTL, E     ; Clear all controll lines
	bcf     LCD_CNTL, RS
	bcf     LCD_CNTL, R_W

	call    delay20		; Wait for 15ms for LCD to get powered up

	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movlw   0x030           ; Command for 4-bit interface high nibble
	iorwf   LCD_DATA,F      ; Send data to LCD      

	bsf     STATUS, RP0     ; Select Register page 1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS   ; Set Port for output
	BCF     STATUS, RP0     ; Select Register page 0

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E

	call    delay5		; Delay for at least 4.1ms before continuing

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E
	
	 
	call    d100mks        ; delay for at least 100usec before continuing
	call    d100mks        ; delay for at least 100usec before continuing

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E

;	call    Wait_Busy       ; From here on, the Busy Bit will be valid.
	call    d100mks        ; delay for at least 100usec before continuing
	call    d100mks        ; delay for at least 100usec before continuing

	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movlw   0x020           ; Command for 4-bit interface high nibble (Really an 8bit command but
				;   lower 4 bits are don't care at this point)
	iorwf   LCD_DATA,F      ; Send data to LCD      

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E

	movlw   FUNCTION_SET    ; Send the function set command 4-bit I/F, Font, Number of lines
	call    Send_Cmd        ; Can now use the Send_Cmd routine since Busy Bit Valid and in 4bit mode.
; LCD Module is now initalized
	return



; --------------------------------------------------------------------
;  
; --------------------------------------------------------------------

delay100	call delay20		;  100 
delay80		call delay20
delay60		call delay20
delay40		call delay20

delay20		call delay5		;  20 
delay15		call delay5
delay10		call delay5

delay5	movlw d'5'
	movwf rab2		; N x 1 ms
delay1	mvi rab3,.249
d1m	nop
	decfsz rab3,f ;	4 x 250 = 1 ms
	goto d1m
	decfsz rab2,f
	goto delay1
	return

d100mks mvi rab3,.25
dll	nop		; 4 x 25 = 100 mkc
	decfsz rab3,f
	goto dll
	return

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
init_reg
	bsf STATUS,RP0	  	;  1
	movlw b'10010111' 	;   256,  rb-,  r  + 
	movwf OPTION_REG-0x80	;   . ,   RTCC
        movlw b'00000000' 	; p 7...0 -  
	movwf TRISB-0x80
	movlw	b'00000000' 	; A4,A3 - , A2,A1,A0 -  ;   
	movwf TRISA-0x80
        bcf STATUS,RP0	  	;  0

	 		;    p p
settr	
	clrf t1hour	;     00-00-00
	clrf t1min
	clrf t1sec
	clrf t50ms
	clrf flag
	clrf PORTA
	clrf PORTB
;	movlw b'10100000' 	; pp   p pp
;	movwf INTCON
	call sound1

	return

;====   interrupt program    ====
;==== p pp  ====
;
;   

interrupt
	bcf INTCON,T0IF 	;   pp !p!
	btfss STATUS,RP0	;     ?
	goto bank0
	bcf STATUS,RP0  ;    -  0- 
	bsf _bank	; ,    1
	goto c_pr
bank0	bcf _bank	;   (   )	
c_pr	movwf push_W 	; p "W"
	swapf push_W,f
	swapf STATUS,w
	movwf push_S ; p  STATUS ( )
	movlw	d'61';   256-61=195 (256=49920)
	movwf	TMR0 ;  p 4 
	incf t50ms,f
	cmp t50ms,d'20'	; 20   50  = 1 
	sz
	goto ret_pr
	clrf t50ms	;  
	incf t1sec,f
	cmp t1sec,d'60' ;  ?
	sz
	goto ret_pr
	clrf t1sec
	mvi t50ms,d'254';   ""  
	incf t1min,f
	cmp t1min,d'60' ;  ?
	sz
	goto ret_pr
	clrf t1min
;      ( -  )
; ..     - 
	mvi t1sec,1	;    1  ...
	mvi t50ms,d'3'	; ...   
	incf t1hour,f
	cmp t1hour,d'24'	;  ?
	sz
	goto ret_pr
	clrf t1hour
ret_pr	bsf _int	;   " pp"
	swapf push_S,w  ;  STATUS
	movwf STATUS	;      
	swapf push_W,w	;  W
	btfsc _bank	; ,     
	bsf STATUS,RP0
	retfie


;*********************************************************************
;              8 Bit binary ---> 3  BCD Number.
;*********************************************************************
;  W   
;         
; rab1 - , rab2 - , rab3 - , W -  
bcd
	clrf rab1	; 
	clrf rab2	; 
	movwf rab3	; 
ghun	movlw .100
	subwf rab3,w
	btfss STATUS,0	; CARRY
	goto gten
	movwf rab3	;   R2
	incf rab1,f	; 
	goto ghun
gten	movlw .10
	subwf rab3,w
	btfss STATUS,0	; CARRY
	goto over
	movwf rab3	;   R2
	incf rab2,f	; 
	goto gten
over	movf rab3,w	;    R2  W
	return

; ===========================================================

sound1
	movlw .1 	; starting bell 3 time
	movwf rab5
so1	call zw1
	call zw2
	call zw3
	call zw4 
	decfsz rab5,f
	goto so1
	return
;--------------------------
zw1	movlw zw1ton
	goto zp
zw2	movlw zw2ton
	goto zp
zw3	movlw zw3ton
	goto zp
zw4	movlw zw4ton
	goto zp
zp	movwf rab1	; period
	movlw d'40'
zwuk	movwf rab2
one_period
	bsf _zw
	call onetdel
	nop
	nop
	nop
	nop
	bcf _zw
	call onetdel
	decfsz rab2,f
	goto one_period
	return
onetdel
	movf rab1,w	; period
	movwf rab3
c_del_1p
	decfsz rab3,f
	goto c_del_1p
	return

;---------------------------------------------------
	END







